Bug 1441089 - oc get/describe could not work when using 3.5 client to login 3.6 server
Summary: oc get/describe could not work when using 3.5 client to login 3.6 server
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: OpenShift Container Platform
Classification: Red Hat
Component: Master
Version: 3.5.0
Hardware: Unspecified
OS: Unspecified
medium
medium
Target Milestone: ---
: 3.5.z
Assignee: Michal Fojtik
QA Contact: Chuan Yu
URL:
Whiteboard:
Depends On:
Blocks: 1463576
TreeView+ depends on / blocked
 
Reported: 2017-04-11 08:21 UTC by Yan Du
Modified: 2017-12-07 07:10 UTC (History)
11 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
: 1463576 (view as bug list)
Environment:
Last Closed: 2017-12-07 07:10:26 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2017:3389 0 normal SHIPPED_LIVE Moderate: Red Hat OpenShift Enterprise security, bug fix, and enhancement update 2017-12-07 12:09:10 UTC

Description Yan Du 2017-04-11 08:21:17 UTC
Description of problem:
When use 3.5 client to connect 3.6 server, some cmd could not work
$ oc get route
NAME      KIND
route1    Route.v1.route.openshift.io

$ oc set route-backends route1
the provided version "route.openshift.io/v1" has no relevant versions: group route.openshift.io has not been registered
no matches for route.openshift.io/, Kind=Route

Version-Release number of selected component (if applicable):
$ oc version
oc v3.5.5
kubernetes v1.5.2+43a9be4
features: Basic-Auth GSSAPI Kerberos SPNEGO

Server https://10.8.174.85:8443
openshift v3.6.26
kubernetes v1.5.2+43a9be4

How reproducible:
Always

Steps to Reproduce:
1. Use a 3.5 version client to login 3.6 server
2. Create some resource, eg, create a route
3. Check the route by #oc get route or #oc describe route


Actual results:
Same as description

Expected results:
3.5 client could work well env when connect to a 3.6 env

Additional info:
3.6 client work well when connect to 3.6 env

Comment 1 Jordan Liggitt 2017-04-11 19:34:30 UTC
oc 3.5 client must prefer the ungrouped APIs

the fix for this is upstream in https://github.com/kubernetes/kubernetes/pull/42275

Comment 2 Michal Fojtik 2017-04-12 08:27:07 UTC
PR: https://github.com/openshift/origin/pull/13727

Comment 3 Michal Fojtik 2017-04-12 12:02:24 UTC
Fix was merged to 1.5 branch of origin, lets wait for next 1.5 build to verify.

Comment 4 Michal Fojtik 2017-04-24 11:42:44 UTC
Guess this should be now available in latest 3.5 puddle.

Comment 5 Chuan Yu 2017-04-25 05:09:38 UTC
Verify failed with latest 3.5 puddle
$ oc version
oc v3.5.5.9
kubernetes v1.5.2+43a9be4
features: Basic-Auth GSSAPI Kerberos SPNEGO

Server https://******
openshift v3.6.47
kubernetes v1.5.2+43a9be4


$ oc get route
NAME      KIND
jenkins   Route.v1.route.openshift.io

$ oc describe route jenkins
the provided version "route.openshift.io/v1" has no relevant versions: group route.openshift.io has not been registered
no matches for route.openshift.io/, Kind=Route

Comment 6 Liang Xia 2017-05-04 09:48:14 UTC
$ oc version
oc v3.5.5.12
kubernetes v1.5.2+43a9be4

$ oc volume dc/mydb --add --type=emptyDir --mount-path=/opt1 --name=n1
the provided version "apps.openshift.io/v1" has no relevant versions: group apps.openshift.io has not been registered
no matches for apps.openshift.io/, Kind=DeploymentConfig

Comment 7 Michal Fojtik 2017-05-04 10:47:08 UTC
(In reply to Liang Xia from comment #6)
> $ oc version
> oc v3.5.5.12
> kubernetes v1.5.2+43a9be4
> 
> $ oc volume dc/mydb --add --type=emptyDir --mount-path=/opt1 --name=n1
> the provided version "apps.openshift.io/v1" has no relevant versions: group
> apps.openshift.io has not been registered
> no matches for apps.openshift.io/, Kind=DeploymentConfig

What is the server version you are running this command against?
Can you also make sure you remove the client cache? Also can you please provide output of this command with --loglevel=10 ?

Comment 8 Liang Xia 2017-05-04 11:11:44 UTC
$ oc version
oc v3.5.5.12
kubernetes v1.5.2+43a9be4
features: Basic-Auth GSSAPI Kerberos SPNEGO

Server ****(dev-preview-int)****
openshift v3.6.63
kubernetes v1.6.1+5115d708d7

Comment 10 Michal Fojtik 2017-05-04 11:46:58 UTC
Liang, I cannot reproduce this locally:

[@dev] .../openshift/origin # oc version
oc v1.5.0+031cbe4
kubernetes v1.5.2+43a9be4
features: Basic-Auth

Server https://192.168.64.3:8443
openshift v3.6.0-alpha.1+dcd60bd-397
kubernetes v1.6.1+5115d708d7
[@dev] .../openshift/origin # oc new-project test
Now using project "test" on server "https://192.168.64.3:8443".

You can add applications to this project with the 'new-app' command. For example, try:

    oc new-app centos/ruby-22-centos7~https://github.com/openshift/ruby-ex.git

to build a new example application in Ruby.
[@dev] .../openshift/origin # oc run nginx --image=nginx
deploymentconfig "nginx" created
[@dev] .../openshift/origin # oc volume  dc/nginx --add --type=emptyDir --mount-path=/opt1 --name=n1
deploymentconfig "nginx" updated

Comment 17 Michal Fojtik 2017-06-20 11:26:04 UTC
Sorry, now I see the problem... https://github.com/openshift/ose/pull/696 somehow managed to not get merged...

Merging this now, we should be able to test this with the latest 3.5 puddle.

Comment 18 Chuan Yu 2017-06-21 02:51:35 UTC
The issue was fixed with latest 3.5 puddle, oc edit/get/describe resources all successfully.

$ oc version
oc v3.5.5.28
kubernetes v1.5.2+43a9be4
features: Basic-Auth GSSAPI Kerberos SPNEGO

Server https://master:8443
openshift v3.6.121
kubernetes v1.6.1+5115d708d7

Comment 19 Michal Fojtik 2017-06-21 09:10:39 UTC
Moving ON_QA.

Comment 20 XiaochuanWang 2017-06-26 08:09:20 UTC
Tested bc, build, dc, pod, deployment, route, svc, hpa, job, secret, statefulset, configmap. 
This is still reproduced for BC (Only BC reproduces in above resources)

# oc get bc
NAME                TYPE      FROM      LATEST
ruby-sample-build   Source    Git       1
# oc describe bc ruby-hello-world
Error from server (NotFound): buildconfigs.build.openshift.io "ruby-hello-world" not found
# oc get bc/ruby-hello-world -o yaml
Error from server (NotFound): buildconfigs.build.openshift.io "ruby-hello-world" not found

Client:
oc v3.5.5.30
kubernetes v1.5.2+43a9be4

Server:
openshift v3.6.122
kubernetes v1.6.1+5115d708d7

Comment 21 Xingxing Xia 2017-06-26 13:44:45 UTC
oc get/describe bc/name works for me. You get "ruby-sample-build" but describe "ruby-hello-world". The name is typo.

Comment 24 errata-xmlrpc 2017-12-07 07:10:26 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2017:3389


Note You need to log in before you can comment on or make changes to this bug.